/*
 * Myfreight Shipping WooCommerce Address Helper Script
 */
jQuery.noConflict();

jQuery(function() {
	/* Autocomplete for Shipping Locality */
	function localityAutocomplete() {
		jQuery('input.locality_autocomplete,#billing_city,#billing_postcode,#shipping_city,#shipping_postcode').autocomplete({
			minLength: 3,
			delay: 300,
			maxResults: 90,
			source: function(request, response) {
				var results = jQuery.ui.autocomplete.filter(myfreightLocalities, request.term);
				response(results.slice(0, this.options.maxResults));
			},
//			position: { collision: 'flip' },
			select: function(event, ui) {
				var locality = ui.item.value.trim().split(' ');
				var postcode = locality[locality.length-1];
				var state = locality[locality.length-2];
				var city = locality.slice(0, locality.length-2).join(' ');
				var country = 'AU';

				if (postcode && state && city) {
					var addressPrefix;
					var inputId = event.target.id.split('_');
					if (inputId[1] == 'locality') {
						addressPrefix = 'calc_shipping';
					} else {
						addressPrefix = inputId[0];
					}
					jQuery('#'+addressPrefix+'_country').val(country).trigger('change');
					jQuery('#'+addressPrefix+'_city').val(city).trigger('change');
					jQuery('#'+addressPrefix+'_state').val(state).trigger('change');
					jQuery('#'+addressPrefix+'_postcode').val(postcode).trigger('change');
					if (inputId[0] == 'product') {
						jQuery('button.rp_calc_shipping_all').trigger('click');
					} else if (inputId[0] == 'cart') {
						jQuery('form.woocommerce-shipping-calculator').submit();
//						return false;
					} else {
						return false;
					}
				}
			}
		});
		jQuery('#product_locality_field').addClass('hide_change_address');
		jQuery('#cart_locality_field').addClass('hide_change_address');
	}
	localityAutocomplete.call();
	jQuery(document).ajaxSuccess( localityAutocomplete );
	jQuery('input.locality_autocomplete').attr('autocomplete', 'receiver-locality');
});

if (jQuery('body.woocommerce-cart').length) {
	/* Add unloading capability field to shipping calculator */
	function unloadingCapabilityCart() {
		if (jQuery('#cart_unloading_capability').length && jQuery('#calc_shipping_unloading').length == 0) {
			var input = jQuery('<input type="text" class"input-text" id="calc_shipping_unloading" name="calc_shipping_unloading" placeholder="Unloading Capability" style="display:none" />');
			jQuery('#calc_shipping_postcode_field').after(input);
			jQuery('#calc_shipping_unloading').val(jQuery('#cart_unloading_capability').is(':checked') ? 1 : 0);
			jQuery('#cart_unloading_capability').on('change', function() {
				jQuery('#calc_shipping_unloading').val(jQuery('#cart_unloading_capability').is(':checked') ? 1 : 0);
				jQuery('form.woocommerce-shipping-calculator').submit();
			});
		}
	}
	unloadingCapabilityCart.call();
	jQuery(document).ajaxSuccess( unloadingCapabilityCart );
	/* Add address type field to shipping calculator */
	function addressTypeCart() {
		if (jQuery('#cart_address_type').length && jQuery('#calc_shipping_address_type').length == 0) {
			var input = jQuery('<input type="text" class"input-text" id="calc_shipping_address_type" name="calc_shipping_address_type" placeholder="Address Type" style="display:none" />');
			jQuery('#calc_shipping_postcode_field').after(input);
			jQuery('#calc_shipping_address_type').val(jQuery('#cart_address_type').is(':checked') ? 1 : 0);
			jQuery('#cart_address_type').on('change', function() {
				jQuery('#calc_shipping_address_type').val(jQuery('#cart_address_type').is(':checked') ? 1 : 0);
				jQuery('form.woocommerce-shipping-calculator').submit();
			});
		}
	}
	addressTypeCart.call();
	jQuery(document).ajaxSuccess( addressTypeCart );
}

if (jQuery('body.woocommerce-checkout').length) {
	/* Validate Billing and Shipping Locality */
	jQuery(function localityValidate() {
		var billingLocality, shippingLocality, shippingAdd, billingValid, shippingValid, locLen, i;

		billingLocality = jQuery('#billing_city').val().trim() + ' ' + jQuery('#billing_state').val() + ' ' + jQuery('#billing_postcode').val().trim();
		billingLocality = billingLocality.toLowerCase();

		shippingAdd = jQuery('#ship-to-different-address-checkbox').is(':checked');
		if (shippingAdd) {
			shippingLocality = jQuery('#shipping_city').val().trim() + ' ' + jQuery('#shipping_state').val() + ' ' + jQuery('#shipping_postcode').val().trim();
			shippingLocality = shippingLocality.toLowerCase();
		}
		billingValid = false;
		shippingValid = false;
		locLen = myfreightLocalities.length;
		for (i=0; i < locLen; i++) {
			myfreightLocality = myfreightLocalities[i].trim().toLowerCase();
			if (!billingValid && (billingLocality == myfreightLocality)) {
				billingValid = true;
			}
			if (shippingAdd && !shippingValid && (shippingLocality == myfreightLocality)) {
				shippingValid = true;
			}
			if (billingValid && (!shippingAdd || shippingValid)) {
				break;
			}
		}
		if (billingValid) {
			jQuery('#billing_city,#billing_state,#billing_postcode').removeClass('invalid-locality');
		} else {
			jQuery('#billing_city,#billing_state,#billing_postcode').addClass('invalid-locality');
		}
		if (shippingAdd) {
			if (shippingValid) {
				jQuery('#shipping_city,#shipping_state,#shipping_postcode').removeClass('invalid-locality');
			} else {
				jQuery('#shipping_city,#shipping_state,#shipping_postcode').addClass('invalid-locality');
			}
		}
		setTimeout(localityValidate, 3000);
	});
	/* Handle company fields changes in checkout */
//	function companyEditCheckout() {
//		if (jQuery('#billing_company').length) {
//			jQuery('#billing_company').on('change', function() {
//				if (!jQuery('#ship-to-different-address-checkbox').is(':checked')) {
//					jQuery('#billing_state').trigger('change');
//					jQuery(document.body).trigger('country_to_state_changed');	// Problem: Shipping rates not recalculating unless rates cache cleared
//				}
//			});
//		}
//		if (jQuery('#shipping_company').length) {
//			jQuery('#shipping_company').on('change', function() {
//				if (jQuery('#ship-to-different-address-checkbox').is(':checked')) {
//					jQuery('#shipping_state').trigger('change');
//					jQuery(document.body).trigger('country_to_state_changed');
//				}
//			});
//		}
//	}
//	companyEditCheckout.call();
	/* Handle address type field in checkout */
	function addressTypeCheckout() {
		if (jQuery('#address_type_field').length) {
			jQuery('#address_type').on('change', function() {
				var addressTypeValue = jQuery('#address_type').is(':checked') ? 1 : 0;
				jQuery.ajax({
					url: wc_checkout_params.ajax_url,
					type: 'POST',
					async: false,
					cache: false,
					data: { 'action': 'receiver_address_type', 'address_type': addressTypeValue },
					dataType: 'json',
					success: function(status) {
						if (jQuery('#ship-to-different-address-checkbox').is(':checked')) {
							jQuery('#shipping_state').trigger('change');
						} else {
							jQuery('#billing_state').trigger('change');
						}
						jQuery(document.body).trigger('country_to_state_changed');
					},
					error: function() {
						console.log('Address type checkbox AJAX update failed');
					}
				});
			});
		}
	}
	addressTypeCheckout.call();
	/* Handle unloading capability field in checkout */
	function unloadingCapabilityCheckout() {
		if (jQuery('#unloading_capability_field').length) {
			jQuery('#unloading_capability').on('change', function() {
				var unloadingValue = jQuery('#unloading_capability').is(':checked') ? 1 : 0;
				jQuery.ajax({
					url: wc_checkout_params.ajax_url,
					type: 'POST',
					async: false,
					cache: false,
					data: { 'action': 'unloading_capability', 'unloading_capability': unloadingValue },
					dataType: 'json',
					success: function(status) {
						if (jQuery('#ship-to-different-address-checkbox').is(':checked')) {
							jQuery('#shipping_state').trigger('change');
						} else {
							jQuery('#billing_state').trigger('change');
						}
						jQuery(document.body).trigger('country_to_state_changed');
					},
					error: function() {
						console.log('Unloading capability checkbox AJAX update failed');
					}
				});
			});
		}
	}
	unloadingCapabilityCheckout.call();
}

